#include <libac.h>

void delay_ms(uint16_t ms)
{
  asm volatile (
        "mov	r30, %0"	"\n\t"		\
        "mov	r31, %1"	"\n\t"		\
        "adiw	r30, 0"		"\n\t"		\
        "breq	__delay_ms2"	"\n\t"		\
        "push	r24"		"\n\t"		\
        "push	r25"		"\n\t"		\
    "__delay_ms0:"		"\n\t"		\
        "ldi	r24, %2"	"\n\t"		\
        "ldi	r25, %3"	"\n\t"		\
    "__delay_ms1:"		"\n\t"		\
        "sbiw	r24, 1"		"\n\t"		\
        "brne	__delay_ms1"	"\n\t"		\
        "wdr"			"\n\t"		\
        "sbiw	r30, 1"		"\n\t"		\
        "brne	__delay_ms0"	"\n\t"		\
        "pop	r25"		"\n\t"		\
        "pop	r24"		"\n\t"		\
    "__delay_ms2:"		"\n\t"		\
        : /* no outputs */			\
        : "r" (ms & 0xff),			\
          "r" ((ms >> 8) & 0xff),		\
          "M" (DELAY_1MS_COUNT & 0xff),		\
          "M" ((DELAY_1MS_COUNT >> 8) & 0xff)	\
  );
}
